/*###############################################################################
# Linux Management Providers (LMP), DNS provider package
# Copyright (C) 2007 Ilsoo Byun <widepis@etri.re.kr ,widepis@empal.com>
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Khahramon NURIDDINOV, TUIT <qahramon0786@gmail.com>
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr>
###############################################################################*/

#ifndef OPENDRIM_COMPUTERSYSTEMDNSGENERALSETTINGDATAACCESS_H_
#define OPENDRIM_COMPUTERSYSTEMDNSGENERALSETTINGDATAACCESS_H_

#include "DNS_Common.h"

#include "OpenDRIM_ComputerSystemDNSGeneralsettingData.h"
#include "assocOpenDRIM_ComputerSystemDNSGeneralsettingData.h"

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_load(const CMPIBroker* broker, string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_unload(string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_ComputerSystemDNSGeneralsettingData>& instances, const char** properties, string& errorMessage, const string& discriminant);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_ComputerSystemDNSGeneralsettingData& instance, const char** properties, string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemDNSGeneralsettingData& newInstance, const OpenDRIM_ComputerSystemDNSGeneralsettingData& oldInstance, const char** properties, string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemDNSGeneralsettingData& instance, string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemDNSGeneralsettingData& instance, string& errorMessage);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_associatorSettingDataToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& SettingData_instance, const char** properties, vector<Instance>& ManagedElement_associatedInstances, string& errorMessage, const string& discriminant);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_associatorManagedElementToSettingData(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const char** properties, vector<Instance>& SettingData_associatedInstances, string& errorMessage, const string& discriminant);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_referenceSettingDataToManagedElement(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& SettingData_instance, const vector<Instance>& ManagedElement_instances, vector<OpenDRIM_ComputerSystemDNSGeneralsettingData>& OpenDRIM_ComputerSystemDNSGeneralsettingData_instances, const char** properties, string& errorMessage, const string& discriminant);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_referenceManagedElementToSettingData(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& ManagedElement_instance, const vector<Instance>& SettingData_instances, vector<OpenDRIM_ComputerSystemDNSGeneralsettingData>& OpenDRIM_ComputerSystemDNSGeneralsettingData_instances, const char** properties, string& errorMessage, const string& discriminant);

int DNS_OpenDRIM_ComputerSystemDNSGeneralsettingData_populate(OpenDRIM_ComputerSystemDNSGeneralsettingData& instance, string& errorMessage);

#endif /*OPENDRIM_COMPUTERSYSTEMDNSGENERALSETTINGDATAACCESS_H_*/
